Merge remote branch 'price/master'
[git/price.git] / git-rebase--interactive.sh
blob3a1bf8613844427837da3a3f3d472609d6e9fd92
1 #!/bin/sh
3 # Copyright (c) 2006 Johannes E. Schindelin
5 # SHORT DESCRIPTION
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
13 OPTIONS_KEEPDASHDASH=
14 OPTIONS_SPEC="\
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
18 Available options are
19 v,verbose display a diffstat of what changed upstream
20 onto= rebase onto given branch instead of upstream
21 p,preserve-merges try to recreate merges instead of ignoring them
22 s,strategy= use the given merge strategy
23 m,merge always used (no-op)
24 i,interactive always used (no-op)
25 Actions:
26 continue continue rebasing process
27 abort abort rebasing process and restore original branch
28 skip skip current patch and continue rebasing process
29 no-verify override pre-rebase hook from stopping the operation
30 root rebase all reachable commmits up to the root(s)
33 . git-sh-setup
34 require_work_tree
36 DOTEST="$GIT_DIR/rebase-merge"
37 TODO="$DOTEST"/git-rebase-todo
38 DONE="$DOTEST"/done
39 MSG="$DOTEST"/message
40 SQUASH_MSG="$DOTEST"/message-squash
41 REWRITTEN="$DOTEST"/rewritten
42 DROPPED="$DOTEST"/dropped
43 PRESERVE_MERGES=
44 STRATEGY=
45 ONTO=
46 VERBOSE=
47 OK_TO_SKIP_PRE_REBASE=
48 REBASE_ROOT=
50 GIT_CHERRY_PICK_HELP=" After resolving the conflicts,
51 mark the corrected paths with 'git add <paths>', and
52 run 'git rebase --continue'"
53 export GIT_CHERRY_PICK_HELP
55 warn () {
56 echo "$*" >&2
59 output () {
60 case "$VERBOSE" in
61 '')
62 output=$("$@" 2>&1 )
63 status=$?
64 test $status != 0 && printf "%s\n" "$output"
65 return $status
68 "$@"
70 esac
73 run_pre_rebase_hook () {
74 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
75 test -x "$GIT_DIR/hooks/pre-rebase"
76 then
77 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
78 echo >&2 "The pre-rebase hook refused to rebase."
79 exit 1
84 require_clean_work_tree () {
85 # test if working tree is dirty
86 git rev-parse --verify HEAD > /dev/null &&
87 git update-index --ignore-submodules --refresh &&
88 git diff-files --quiet --ignore-submodules &&
89 git diff-index --cached --quiet HEAD --ignore-submodules -- ||
90 die "Working tree is dirty"
93 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
95 comment_for_reflog () {
96 case "$ORIG_REFLOG_ACTION" in
97 ''|rebase*)
98 GIT_REFLOG_ACTION="rebase -i ($1)"
99 export GIT_REFLOG_ACTION
101 esac
104 last_count=
105 mark_action_done () {
106 sed -e 1q < "$TODO" >> "$DONE"
107 sed -e 1d < "$TODO" >> "$TODO".new
108 mv -f "$TODO".new "$TODO"
109 count=$(grep -c '^[^#]' < "$DONE")
110 total=$(($count+$(grep -c '^[^#]' < "$TODO")))
111 if test "$last_count" != "$count"
112 then
113 last_count=$count
114 printf "Rebasing (%d/%d)\r" $count $total
115 test -z "$VERBOSE" || echo
119 make_patch () {
120 sha1_and_parents="$(git rev-list --parents -1 "$1")"
121 case "$sha1_and_parents" in
122 ?*' '?*' '?*)
123 git diff --cc $sha1_and_parents
125 ?*' '?*)
126 git diff-tree -p "$1^!"
129 echo "Root commit"
131 esac > "$DOTEST"/patch
132 test -f "$DOTEST"/message ||
133 git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
134 test -f "$DOTEST"/author-script ||
135 get_author_ident_from_commit "$1" > "$DOTEST"/author-script
138 die_with_patch () {
139 make_patch "$1"
140 git rerere
141 die "$2"
144 die_abort () {
145 rm -rf "$DOTEST"
146 die "$1"
149 has_action () {
150 grep '^[^#]' "$1" >/dev/null
153 pick_one () {
154 no_ff=
155 case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
156 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
157 test -d "$REWRITTEN" &&
158 pick_one_preserving_merges "$@" && return
159 if test ! -z "$REBASE_ROOT"
160 then
161 output git cherry-pick "$@"
162 return
164 parent_sha1=$(git rev-parse --verify $sha1^) ||
165 die "Could not get the parent of $sha1"
166 current_sha1=$(git rev-parse --verify HEAD)
167 if test "$no_ff$current_sha1" = "$parent_sha1"; then
168 output git reset --hard $sha1
169 test "a$1" = a-n && output git reset --soft $current_sha1
170 sha1=$(git rev-parse --short $sha1)
171 output warn Fast-forward to $sha1
172 else
173 output git cherry-pick "$@"
177 pick_one_preserving_merges () {
178 fast_forward=t
179 case "$1" in
181 fast_forward=f
182 sha1=$2
185 sha1=$1
187 esac
188 sha1=$(git rev-parse $sha1)
190 if test -f "$DOTEST"/current-commit
191 then
192 if test "$fast_forward" = t
193 then
194 cat "$DOTEST"/current-commit | while read current_commit
196 git rev-parse HEAD > "$REWRITTEN"/$current_commit
197 done
198 rm "$DOTEST"/current-commit ||
199 die "Cannot write current commit's replacement sha1"
203 echo $sha1 >> "$DOTEST"/current-commit
205 # rewrite parents; if none were rewritten, we can fast-forward.
206 new_parents=
207 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
208 if test "$pend" = " "
209 then
210 pend=" root"
212 while [ "$pend" != "" ]
214 p=$(expr "$pend" : ' \([^ ]*\)')
215 pend="${pend# $p}"
217 if test -f "$REWRITTEN"/$p
218 then
219 new_p=$(cat "$REWRITTEN"/$p)
221 # If the todo reordered commits, and our parent is marked for
222 # rewriting, but hasn't been gotten to yet, assume the user meant to
223 # drop it on top of the current HEAD
224 if test -z "$new_p"
225 then
226 new_p=$(git rev-parse HEAD)
229 test $p != $new_p && fast_forward=f
230 case "$new_parents" in
231 *$new_p*)
232 ;; # do nothing; that parent is already there
234 new_parents="$new_parents $new_p"
236 esac
237 else
238 if test -f "$DROPPED"/$p
239 then
240 fast_forward=f
241 replacement="$(cat "$DROPPED"/$p)"
242 test -z "$replacement" && replacement=root
243 pend=" $replacement$pend"
244 else
245 new_parents="$new_parents $p"
248 done
249 case $fast_forward in
251 output warn "Fast-forward to $sha1"
252 output git reset --hard $sha1 ||
253 die "Cannot fast-forward to $sha1"
256 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
258 if [ "$1" != "-n" ]
259 then
260 # detach HEAD to current parent
261 output git checkout $first_parent 2> /dev/null ||
262 die "Cannot move HEAD to $first_parent"
265 case "$new_parents" in
266 ' '*' '*)
267 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
269 # redo merge
270 author_script=$(get_author_ident_from_commit $sha1)
271 eval "$author_script"
272 msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
273 # No point in merging the first parent, that's HEAD
274 new_parents=${new_parents# $first_parent}
275 if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
276 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
277 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
278 output git merge $STRATEGY -m "$msg" \
279 $new_parents
280 then
281 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
282 die_with_patch $sha1 "Error redoing merge $sha1"
286 output git cherry-pick "$@" ||
287 die_with_patch $sha1 "Could not pick $sha1"
289 esac
291 esac
294 nth_string () {
295 case "$1" in
296 *1[0-9]|*[04-9]) echo "$1"th;;
297 *1) echo "$1"st;;
298 *2) echo "$1"nd;;
299 *3) echo "$1"rd;;
300 esac
303 make_squash_message () {
304 if test -f "$SQUASH_MSG"; then
305 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
306 < "$SQUASH_MSG" | sed -ne '$p')+1))
307 echo "# This is a combination of $COUNT commits."
308 sed -e 1d -e '2,/^./{
309 /^$/d
310 }' <"$SQUASH_MSG"
311 else
312 COUNT=2
313 echo "# This is a combination of two commits."
314 echo "# The first commit's message is:"
315 echo
316 git cat-file commit HEAD | sed -e '1,/^$/d'
318 echo
319 echo "# This is the $(nth_string $COUNT) commit message:"
320 echo
321 git cat-file commit $1 | sed -e '1,/^$/d'
324 peek_next_command () {
325 sed -n "1s/ .*$//p" < "$TODO"
328 do_next () {
329 rm -f "$DOTEST"/message "$DOTEST"/author-script \
330 "$DOTEST"/amend || exit
331 read command sha1 rest < "$TODO"
332 case "$command" in
333 '#'*|''|noop)
334 mark_action_done
336 pick|p)
337 comment_for_reflog pick
339 mark_action_done
340 pick_one $sha1 ||
341 die_with_patch $sha1 "Could not apply $sha1... $rest"
343 reword|r)
344 comment_for_reflog reword
346 mark_action_done
347 pick_one $sha1 ||
348 die_with_patch $sha1 "Could not apply $sha1... $rest"
349 git commit --amend
351 edit|e)
352 comment_for_reflog edit
354 mark_action_done
355 pick_one $sha1 ||
356 die_with_patch $sha1 "Could not apply $sha1... $rest"
357 make_patch $sha1
358 git rev-parse --verify HEAD > "$DOTEST"/amend
359 warn "Stopped at $sha1... $rest"
360 warn "You can amend the commit now, with"
361 warn
362 warn " git commit --amend"
363 warn
364 warn "Once you are satisfied with your changes, run"
365 warn
366 warn " git rebase --continue"
367 warn
368 exit 0
370 squash|s)
371 comment_for_reflog squash
373 test -f "$DONE" && has_action "$DONE" ||
374 die "Cannot 'squash' without a previous commit"
376 mark_action_done
377 make_squash_message $sha1 > "$MSG"
378 failed=f
379 author_script=$(get_author_ident_from_commit HEAD)
380 output git reset --soft HEAD^
381 pick_one -n $sha1 || failed=t
382 case "$(peek_next_command)" in
383 squash|s)
384 USE_OUTPUT=output
385 MSG_OPT=-F
386 EDIT_OR_FILE="$MSG"
387 cp "$MSG" "$SQUASH_MSG"
390 USE_OUTPUT=
391 MSG_OPT=
392 EDIT_OR_FILE=-e
393 rm -f "$SQUASH_MSG" || exit
394 cp "$MSG" "$GIT_DIR"/SQUASH_MSG
395 rm -f "$GIT_DIR"/MERGE_MSG || exit
397 esac
398 echo "$author_script" > "$DOTEST"/author-script
399 if test $failed = f
400 then
401 # This is like --amend, but with a different message
402 eval "$author_script"
403 GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
404 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
405 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
406 $USE_OUTPUT git commit --no-verify \
407 $MSG_OPT "$EDIT_OR_FILE" || failed=t
409 if test $failed = t
410 then
411 cp "$MSG" "$GIT_DIR"/MERGE_MSG
412 warn
413 warn "Could not apply $sha1... $rest"
414 die_with_patch $sha1 ""
418 warn "Unknown command: $command $sha1 $rest"
419 die "Please fix this in the file $TODO."
421 esac
422 test -s "$TODO" && return
424 comment_for_reflog finish &&
425 HEADNAME=$(cat "$DOTEST"/head-name) &&
426 OLDHEAD=$(cat "$DOTEST"/head) &&
427 SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
428 NEWHEAD=$(git rev-parse HEAD) &&
429 case $HEADNAME in
430 refs/*)
431 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
432 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
433 git symbolic-ref HEAD $HEADNAME
435 esac && {
436 test ! -f "$DOTEST"/verbose ||
437 git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
438 } &&
439 rm -rf "$DOTEST" &&
440 git gc --auto &&
441 warn "Successfully rebased and updated $HEADNAME."
443 exit
446 do_rest () {
447 while :
449 do_next
450 done
453 # skip picking commits whose parents are unchanged
454 skip_unnecessary_picks () {
455 fd=3
456 while read command sha1 rest
458 # fd=3 means we skip the command
459 case "$fd,$command,$(git rev-parse --verify --quiet $sha1^)" in
460 3,pick,"$ONTO"*|3,p,"$ONTO"*)
461 # pick a commit whose parent is current $ONTO -> skip
462 ONTO=$sha1
464 3,#*|3,,*)
465 # copy comments
468 fd=1
470 esac
471 echo "$command${sha1:+ }$sha1${rest:+ }$rest" >&$fd
472 done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
473 mv -f "$TODO".new "$TODO" ||
474 die "Could not skip unnecessary pick commands"
477 # check if no other options are set
478 is_standalone () {
479 test $# -eq 2 -a "$2" = '--' &&
480 test -z "$ONTO" &&
481 test -z "$PRESERVE_MERGES" &&
482 test -z "$STRATEGY" &&
483 test -z "$VERBOSE"
486 get_saved_options () {
487 test -d "$REWRITTEN" && PRESERVE_MERGES=t
488 test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
489 test -f "$DOTEST"/verbose && VERBOSE=t
490 test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
493 while test $# != 0
495 case "$1" in
496 --no-verify)
497 OK_TO_SKIP_PRE_REBASE=yes
499 --verify)
501 --continue)
502 is_standalone "$@" || usage
503 get_saved_options
504 comment_for_reflog continue
506 test -d "$DOTEST" || die "No interactive rebase running"
508 # Sanity check
509 git rev-parse --verify HEAD >/dev/null ||
510 die "Cannot read HEAD"
511 git update-index --ignore-submodules --refresh &&
512 git diff-files --quiet --ignore-submodules ||
513 die "Working tree is dirty"
515 # do we have anything to commit?
516 if git diff-index --cached --quiet --ignore-submodules HEAD --
517 then
518 : Nothing to commit -- skip this
519 else
520 test -f "$DOTEST"/author-script &&
521 . "$DOTEST"/author-script ||
522 die "Cannot find the author identity"
523 amend=
524 if test -f "$DOTEST"/amend
525 then
526 amend=$(git rev-parse --verify HEAD)
527 test "$amend" = $(cat "$DOTEST"/amend) ||
528 die "\
529 You have uncommitted changes in your working tree. Please, commit them
530 first and then run 'git rebase --continue' again."
531 git reset --soft HEAD^ ||
532 die "Cannot rewind the HEAD"
534 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
535 git commit --no-verify -F "$DOTEST"/message -e || {
536 test -n "$amend" && git reset --soft $amend
537 die "Could not commit staged changes."
541 require_clean_work_tree
542 do_rest
544 --abort)
545 is_standalone "$@" || usage
546 get_saved_options
547 comment_for_reflog abort
549 git rerere clear
550 test -d "$DOTEST" || die "No interactive rebase running"
552 HEADNAME=$(cat "$DOTEST"/head-name)
553 HEAD=$(cat "$DOTEST"/head)
554 case $HEADNAME in
555 refs/*)
556 git symbolic-ref HEAD $HEADNAME
558 esac &&
559 output git reset --hard $HEAD &&
560 rm -rf "$DOTEST"
561 exit
563 --skip)
564 is_standalone "$@" || usage
565 get_saved_options
566 comment_for_reflog skip
568 git rerere clear
569 test -d "$DOTEST" || die "No interactive rebase running"
571 output git reset --hard && do_rest
574 case "$#,$1" in
575 *,*=*)
576 STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
577 1,*)
578 usage ;;
580 STRATEGY="-s $2"
581 shift ;;
582 esac
585 # we use merge anyway
588 VERBOSE=t
591 PRESERVE_MERGES=t
594 # yeah, we know
596 --root)
597 REBASE_ROOT=t
599 --onto)
600 shift
601 ONTO=$(git rev-parse --verify "$1") ||
602 die "Does not point to a valid commit: $1"
605 shift
606 test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
607 test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
608 test -d "$DOTEST" &&
609 die "Interactive rebase already started"
611 git var GIT_COMMITTER_IDENT >/dev/null ||
612 die "You need to set your committer info first"
614 if test -z "$REBASE_ROOT"
615 then
616 UPSTREAM_ARG="$1"
617 UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
618 test -z "$ONTO" && ONTO=$UPSTREAM
619 shift
620 else
621 UPSTREAM=
622 UPSTREAM_ARG=--root
623 test -z "$ONTO" &&
624 die "You must specify --onto when using --root"
626 run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
628 comment_for_reflog start
630 require_clean_work_tree
632 if test ! -z "$1"
633 then
634 output git show-ref --verify --quiet "refs/heads/$1" ||
635 die "Invalid branchname: $1"
636 output git checkout "$1" ||
637 die "Could not checkout $1"
640 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
641 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
643 : > "$DOTEST"/interactive || die "Could not mark as interactive"
644 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
645 echo "detached HEAD" > "$DOTEST"/head-name
647 echo $HEAD > "$DOTEST"/head
648 case "$REBASE_ROOT" in
650 rm -f "$DOTEST"/rebase-root ;;
652 : >"$DOTEST"/rebase-root ;;
653 esac
654 echo $ONTO > "$DOTEST"/onto
655 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
656 test t = "$VERBOSE" && : > "$DOTEST"/verbose
657 if test t = "$PRESERVE_MERGES"
658 then
659 # $REWRITTEN contains files for each commit that is
660 # reachable by at least one merge base of $HEAD and
661 # $UPSTREAM. They are not necessarily rewritten, but
662 # their children might be.
663 # This ensures that commits on merged, but otherwise
664 # unrelated side branches are left alone. (Think "X"
665 # in the man page's example.)
666 if test -z "$REBASE_ROOT"
667 then
668 mkdir "$REWRITTEN" &&
669 for c in $(git merge-base --all $HEAD $UPSTREAM)
671 echo $ONTO > "$REWRITTEN"/$c ||
672 die "Could not init rewritten commits"
673 done
674 else
675 mkdir "$REWRITTEN" &&
676 echo $ONTO > "$REWRITTEN"/root ||
677 die "Could not init rewritten commits"
679 # No cherry-pick because our first pass is to determine
680 # parents to rewrite and skipping dropped commits would
681 # prematurely end our probe
682 MERGES_OPTION=
683 first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
684 else
685 MERGES_OPTION="--no-merges --cherry-pick"
688 SHORTHEAD=$(git rev-parse --short $HEAD)
689 SHORTONTO=$(git rev-parse --short $ONTO)
690 if test -z "$REBASE_ROOT"
691 # this is now equivalent to ! -z "$UPSTREAM"
692 then
693 SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
694 REVISIONS=$UPSTREAM...$HEAD
695 SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
696 else
697 REVISIONS=$ONTO...$HEAD
698 SHORTREVISIONS=$SHORTHEAD
700 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
701 --abbrev=7 --reverse --left-right --topo-order \
702 $REVISIONS | \
703 sed -n "s/^>//p" | while read shortsha1 rest
705 if test t != "$PRESERVE_MERGES"
706 then
707 echo "pick $shortsha1 $rest" >> "$TODO"
708 else
709 sha1=$(git rev-parse $shortsha1)
710 if test -z "$REBASE_ROOT"
711 then
712 preserve=t
713 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
715 if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
716 then
717 preserve=f
719 done
720 else
721 preserve=f
723 if test f = "$preserve"
724 then
725 touch "$REWRITTEN"/$sha1
726 echo "pick $shortsha1 $rest" >> "$TODO"
729 done
731 # Watch for commits that been dropped by --cherry-pick
732 if test t = "$PRESERVE_MERGES"
733 then
734 mkdir "$DROPPED"
735 # Save all non-cherry-picked changes
736 git rev-list $REVISIONS --left-right --cherry-pick | \
737 sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
738 # Now all commits and note which ones are missing in
739 # not-cherry-picks and hence being dropped
740 git rev-list $REVISIONS |
741 while read rev
743 if test -f "$REWRITTEN"/$rev -a "$(grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
744 then
745 # Use -f2 because if rev-list is telling us this commit is
746 # not worthwhile, we don't want to track its multiple heads,
747 # just the history of its first-parent for others that will
748 # be rebasing on top of it
749 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
750 short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
751 grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
752 rm "$REWRITTEN"/$rev
754 done
757 test -s "$TODO" || echo noop >> "$TODO"
758 cat >> "$TODO" << EOF
760 # Rebase $SHORTREVISIONS onto $SHORTONTO
762 # Commands:
763 # p, pick = use commit
764 # r, reword = use commit, but edit the commit message
765 # e, edit = use commit, but stop for amending
766 # s, squash = use commit, but meld into previous commit
768 # If you remove a line here THAT COMMIT WILL BE LOST.
769 # However, if you remove everything, the rebase will be aborted.
773 has_action "$TODO" ||
774 die_abort "Nothing to do"
776 cp "$TODO" "$TODO".backup
777 git_editor "$TODO" ||
778 die "Could not execute editor"
780 has_action "$TODO" ||
781 die_abort "Nothing to do"
783 test -d "$REWRITTEN" || skip_unnecessary_picks
785 git update-ref ORIG_HEAD $HEAD
786 output git checkout $ONTO && do_rest
788 esac
789 shift
790 done